include \masm32\ultrano\bank\base.inc
include ..\sDraw\sDraw.inc
includelib ..\sDraw\sDraw.lib
.data?
	hinst dd ?
	hwndMain dd ?
	bmp1	dd ?
	font1	dd ?
.data
	ToolsViewHei dd 100
	ToolsRealHei dd 128
	MainRgn	     dd 0
	
	bIsActive	dd 0
	ClockDigitsAlpha dd 0
.code
	
WIN_WID	equ 233
WIN_HEI equ 55

includelib bmp1_bmp.lib
externdef bmp1_bmp:byte

FP macro what
	local x
.data
	x real4 what
.code
	exitm <x>
endm


XTask struct
	ActionTimeLeft	dd ?
	IsDaily		db ?
	IsActive	db ?
	
XTask ends
	

include data.inc

;=====<< iUpdateRgn >>===\
iUpdateRgn proc
	local rgn1,rgn2
	local rect:RECT,pt:POINT
	.data
		prevViewHei dd -1
		prevBActive dd -1
	.code
	
	
	;------[ check if useless ]----------------------[
	mov edx,bIsActive
	mov eax,ToolsViewHei
	.if eax==prevViewHei && edx==prevBActive
		ret
	.endif
	mov prevViewHei,eax
	mov prevBActive,edx
	;------------------------------------------------/
	;------[ check if tiny ]----------------------[
	.if !bIsActive
		invoke CreateRectRgn,104,6,227,28
		mov rgn1,eax
		jmp _AdjustTitle
	.endif
	;---------------------------------------------/
	
	;--------[ make rgn2 (the slider ]---------------------[
	invoke ExtCreateRegion,0,IRegion2_size,IRegion2
	mov rgn2,eax
	
	mov edx,32
	add edx,ToolsViewHei
	invoke OffsetRgn,eax,0,edx
	;------------------------------------------------------/
	
	
	;------[ make rgn1, combine with rgn2 ]------------[
	invoke ExtCreateRegion,0,IRegion1_size,IRegion1
	mov rgn1,eax
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_OR
	invoke DeleteObject,rgn2
	;--------------------------------------------------/
	
	;------[ make tools-region (rect) ]-------------[
	.if ToolsViewHei
		mov eax,32
		add eax,ToolsViewHei
		invoke CreateRectRgn,0,32,WIN_WID,eax
		push eax
		invoke CombineRgn,rgn1,rgn1,eax,RGN_OR
		call DeleteObject
	.endif
	;-----------------------------------------------/
	
	;------[ adjust rgn1, since we have a window-title ]------[
	_AdjustTitle:
	invoke GetWindowRect,hwndMain,addr rect
	m2m pt.x,rect.left
	m2m pt.y,rect.top
	invoke ScreenToClient,hwndMain,addr pt
	neg pt.x
	neg pt.y
	invoke OffsetRgn,rgn1,pt.x,pt.y
	;---------------------------------------------------------/
	
	;--------[ set the region ]-------------[
	;invoke InvalidateRect,hwndMain,0,1
	invoke SetWindowRgn,hwndMain,rgn1,1
	.if MainRgn
		invoke DeleteObject,MainRgn
	.endif
	m2m MainRgn,rgn1
	;---------------------------------------/
	ret
iUpdateRgn endp
;=======/



.data?
	pGE_Menu	dd ?
	
	set pGE_Menu as ObjVector
	
.code
	
GE_FocusMenu proto MenuID:DWORD

;ATC_EnlistProcs = 1
class GElement,,C++ compatible
	void GElement:x,y,wid,hei,EID
	long x
	long y
	long wid
	long hei
	long Alpha
	long tx
	long ty
	
	long EID
	
	virtual Draw:
	virtual OnClick:
	
	static mx dd ? ; mouse x
	static my dd ? ; mouse y
	
endclass

assume ecx:ptr GElement

GElement_GElement proc x,y,wid,hei,EID
	m2m [ecx].x,x
	m2m [ecx].y,y
	m2m [ecx].tx,x
	m2m [ecx].ty,y
	m2m [ecx].wid,wid
	m2m [ecx].hei,hei
	m2m [ecx].EID,EID
	ret
GElement_GElement endp
GElement_$GElement proc
	
	ret
GElement_$GElement endp
	


GElement_Draw proc
	;----[ fade-out ]------------[
	mov eax,[ecx].Alpha
	.if eax
		sub eax,32
		jns @F
		xor eax,eax
		@@:
		mov [ecx].Alpha,eax
	.endif
	;----------------------------/
	;----[ highlight ]--------[
	mov eax,GElement_mx
	mov edx,GElement_my
	sub eax,[ecx].x
	jl @F
	sub edx,[ecx].y
	jl @F
	cmp eax,[ecx].wid
	jge @F
	cmp edx,[ecx].hei
	jge @F
	mov [ecx].Alpha,255
	@@:
	;-------------------------/
	;---[ move ]--------------[
	mov eax,[ecx].x
	mov edx,[ecx].tx
	.if eax!=edx
		lea eax,[eax+eax*4]
		lea edx,[edx+edx*2]
		add eax,edx
		add eax,4
		sar eax,3
		mov [ecx].x,eax
	.endif
	mov eax,[ecx].y
	mov edx,[ecx].ty
	.if eax!=edx
		lea eax,[eax+eax*4]
		lea edx,[edx+edx*2]
		add eax,edx
		add eax,4
		sar eax,3
		mov [ecx].y,eax
	.endif
	;-------------------------/
	
	call GEE_Draw
	
	ret
GElement_Draw endp

GElement_OnClick proc
	call GEE_Click
	ret
GElement_OnClick endp

class GTxtElement,GElement,C++ compatible
	void GTxtElement:x,y,wid,hei,EID,pTxt:x,y,wid,hei,EID
	long pText
	virtual Draw:
endclass

assume ecx:ptr GTxtElement

GTxtElement_GTxtElement proc x,y,wid,hei,EID,pTxt
	m2m [ecx].pText,pTxt
	ret
GTxtElement_GTxtElement endp
GTxtElement_$GTxtElement proc
	
	ret
GTxtElement_$GTxtElement endp




GTxtElement_Draw proc
	invoke GElement_Draw
	mov edx,RGB(103,121,139)
	mov eax,[ecx].Alpha
	mov ah,al
	shl eax,8
	mov al,ah
	movd mm0,eax
	movd mm1,edx
	paddusb mm0,mm1
	movd eax,mm0
	emms
	
	invoke sTextOut,[ecx].x,[ecx].y,[ecx].pText,eax
	ret
GTxtElement_Draw endp








assume ecx:nothing



GE_DrawAll proc x,y
	local pt:POINT
	
	invoke GetCursorPos,addr pt
	invoke ScreenToClient,hwndMain,addr pt
	
	mov eax,pt.x
	mov edx,pt.y
	sub eax,x
	sub edx,y
	mov GElement_mx,eax
	mov GElement_my,edx
	
	
	foreachUnsafe pGE_Menu,icall edx,GElement,Draw
	
	ret
GE_DrawAll endp


GE_OnClick proc
	xor ecx,ecx
	foreachUnsafe pGE_Menu, multi cmp [edx].GElement.Alpha,255 | jne @F | mov ecx,edx | @@:
	
	.if ecx
		icall ecx,GElement,OnClick
	.else
		invoke PostMessage,hwndMain,WM_NCLBUTTONDOWN,HTCAPTION,0
	.endif
	ret
GE_OnClick endp


GEE_Draw proc
	mov eax,[ecx].GElement.EID
	
	ret
GEE_Draw endp

GEE_Click proc
	mov eax,[ecx].GElement.EID
	.if eax==0
		invoke GE_FocusMenu,1
	.endif
	
	ret
GEE_Click endp

NEWTXT macro x,y,wid,hei,txt:VARARG
	local szText
	ifndef @NUMGEE
		@NUMGEE = 0
	endif
	.data
	szText byte txt, 0
	.code
		mov eax,new(GTxtElement,x,y,wid,hei,@NUMGEE,offset szText)
	pcall pGE_Menu.insert,eax
	@NUMGEE = @NUMGEE+1
endm

GE_InitClasses proc
	mov pGE_Menu,new(ObjVector)
	
	
	NEWTXT 20,10,100,10,"New once-time alarm"
	NEWTXT 20,30,100,10,"New everyday event"
	NEWTXT 20,50,100,10,"View upcoming events"
	
	NEWTXT 420,10,100,10,"Coffee (1 min)"
	NEWTXT 420,25,100,10,"Boiler (30 mins)"
	NEWTXT 420,40,100,10,"Veranda rest (90 mins)"
	NEWTXT 420,55,100,10,"Push-ups (2 hrs)"
	NEWTXT 430,75,100,10,"<Custom event>"
	
	ret
GE_InitClasses endp

GE_FocusMenu proc MenuID
	local pFocus
	mov eax,WIN_WID+10
	mov ecx,100
	foreachUnsafe pGE_Menu,multi mov [edx].GElement.tx,eax | mov [edx].GElement.ty,ecx | add eax,20 
	
	mov edx,pGE_Menu
	mov edx,[edx].ObjVector.MyData
	@GE_FMSE macro XID,itx,ity
		mov eax,[edx+XID*4]
		mov [eax].GElement.tx,itx
		mov [eax].GElement.ty,ity
	endm	
	
	.if MenuID==1
		@GE_FMSE 3,20,10
		@GE_FMSE 4,20,25
		@GE_FMSE 5,20,40
		@GE_FMSE 6,20,55
		@GE_FMSE 7,50,85
	.else ; main menu
		@GE_FMSE 0,20,10
		@GE_FMSE 1,20,30
		@GE_FMSE 2,20,50
	.endif
	
		
		
	
	
	ret
GE_FocusMenu endp

DrawDouble proc x,y ; the number is in eax, ebx=0 or 100, the opacity in esi=0..256
	; eax=0..99
	push eax
	mov edx,3435973837
	mul edx
	SHR edx, 3
	mov ecx,edx
	lea ecx,[ecx+ecx*4]
	shl ecx,1
	pop eax
	sub eax,ecx
	; ok , eax=0..9, edx=0..9 , edx*10+eax= original_number
	lea eax,[eax+eax*4]
	lea edx,[edx+edx*4]
	lea eax,[eax*2+ebx]
	lea edx,[edx*2+ebx]
	invoke sBltAddFade,x,y,10,13,edx,80,esi
	add x,10
	invoke sBltAddFade,x,y,10,13,eax,80,esi
	
	ret
DrawDouble endp

OnDraw proc UseAll
	local syst:SYSTEMTIME
	local m:POINT
	local baka
	
	
	invoke sdStart,hwndMain
	jz _ret
	
	invoke GetCursorPos,addr m
	invoke ScreenToClient,hwndMain,addr m
	
	invoke sdSetSourceSprite,bmp1
	invoke sBlt,0,0,WIN_WID,33,0,0
	mov eax,ToolsViewHei
	add eax,32
	invoke sBlt,0,eax,WIN_WID,22,0,32
	
	
	
	
	
	;-------[ draw time ]-----------\
	invoke GetLocalTime,addr syst
	mov esi,ClockDigitsAlpha
	shl esi,3
	mov ebx,100
	movzx eax,syst.wHour
	invoke DrawDouble,115,10
	movzx eax,syst.wMinute
	invoke DrawDouble,140,10
	movzx eax,syst.wSecond
	invoke DrawDouble,165,10
	movzx eax,syst.wMilliseconds
	mov edx,3435973837
	mul edx
	SHR edx,3
	mov eax,edx
	invoke DrawDouble,200,10
	.if ClockDigitsAlpha<32
		inc ClockDigitsAlpha
	.endif
	;-------------------------------/
	
	
	;----------[ draw menu ]------------------------[
	invoke sdEnterClip,0,32,WIN_WID,ToolsViewHei
	.if eax
		invoke sBltTile,0,0,WIN_WID,ToolsViewHei,166,54,64,16,0,0
		
		invoke GE_DrawAll,0,32
		
		invoke sdLeaveClip
	.endif
	;-----------------------------------------------/
	
	
	
	movzx eax,syst.wMilliseconds
	and eax,128
	invoke sBltAddFade,105,16,9,10,156,54,eax
	
	
	invoke sdEnd
	
	
	;-----[ animate slider up/down ]------\
	fild ToolsViewHei
	fmul FP(0.8)
	fild ToolsRealHei
	fmul FP(0.2)
	fadd
	fsub FP(0.5)
	fistp ToolsViewHei		
	;-------------------------------------/
	
	
_ret:	ret
OnDraw endp

	

	
;----------[ creates an arbitrary window ]---------------------[
MakeOneWindow proc wid,hei,pFunc,pTitle,wndClass,dwStyle1,dwStyleEx
	local wc:WNDCLASSEX
	local rect:RECT
	
	Clear wc
	mov wc.cbSize,sizeof  wc
	
	push pFunc
	pop wc.lpfnWndProc
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	m2m wc.hInstance,hinst
	m2m wc.lpszClassName,wndClass
	mov wc.style,3820h
	invoke RegisterClassEx,addr wc
	;-------------------------------------------/
	;-----[ adjust window size ]---------\
	mov rect.left,0
	mov rect.top,0
	push wid
	pop rect.right
	push hei
	pop rect.bottom
	invoke AdjustWindowRectEx,addr rect,dwStyle1,0,dwStyleEx
	mov eax,rect.right
	sub eax,rect.left
	mov ecx,rect.bottom
	sub ecx,rect.top
	;------------------------------------/
	invoke CreateWindowEx,dwStyleEx,wndClass,pTitle,dwStyle1,50,50,eax,ecx,0,0,hinst,0
	ret
MakeOneWindow endp
;--------------------------------------------------------------/
	
	
;--------------[ main window's procedure ]------------------------[
WinProc proc hWnd,msg,w,l
	local rect:RECT
	.if msg==WM_CLOSE
		invoke PostQuitMessage,0
	.elseif msg==WM_PAINT
		invoke ValidateRect,hWnd,0
		invoke OnDraw
	.elseif msg==WM_LBUTTONDOWN
		mov eax,l
		shr eax,16
		.if eax<33
			invoke PostMessage,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,0 
		.else
			sub eax,33
			.if eax<ToolsRealHei
				invoke GE_OnClick
			.else
				xor ToolsRealHei,128
			.endif
		.endif			
	.elseif msg==WM_RBUTTONDOWN
		invoke GE_FocusMenu,0
	.elseif msg==WM_KEYDOWN && w==VK_ESCAPE
		invoke PostQuitMessage,0
	.elseif msg==WM_TIMER && w==1
		invoke PostQuitMessage,0
	.elseif msg==WM_TIMER && w==2
		invoke iUpdateRgn
		invoke OnDraw
		
	.elseif msg==WM_ACTIVATEAPP
		m2m bIsActive,w		
		invoke OnDraw
	.else
		invoke DefWindowProc,hWnd,msg,w,l
		ret
	.endif
	xor eax,eax
	ret
WinProc endp
;------------------------------------------------------------------/

SQWNDSTYLE	equ	04CA0000h
SQWNDSTYLEEX	equ	190h or WS_EX_TOPMOST
	
main proc
	local msg:MSG
	
	invoke GE_InitClasses
	
	
	invoke InitSDraw,WIN_WID,200
	mov bmp1,$invoke(sdSpriteFromILB,addr bmp1_bmp)
	mov font1,$invoke(sdLoadFont,Font1_fntdata)
	mov SD_CurFont,eax
	
	
	invoke MakeOneWindow,WIN_WID,WIN_HEI+200,WinProc,T("ClockX"),T("ClockXWnd"),SQWNDSTYLE,SQWNDSTYLEEX
	mov hwndMain,eax
	invoke iUpdateRgn
	invoke ShowWindow,hwndMain,SW_SHOWNORMAL
	;invoke SetTimer,hwndMain,1,5000,0 ; auto-exit
	invoke SetTimer,hwndMain,2,50,0
	MessageLoop
	invoke DestroyWindow,hwndMain
	invoke FreeSDraw
	ret
main endp

	
	
start:
invoke GetModuleHandle,0
mov hinst,eax
call main
invoke ExitProcess,0
end start
